SystemOrganization addCategory: #MartinDiasPersonalStuff!

!MCCacheRepository class methodsFor: '*martindiaspersonalstuff' stamp: 'MartinDias 11/22/2011 17:36'!
marianoDefaultWithDirectory: aDirectory
	self checkCacheDirectory.
	^ default ifNil: [default := self new directory: aDirectory]! !

!MCCacheRepository class methodsFor: '*martindiaspersonalstuff' stamp: 'MartinDias 11/22/2011 17:36'!
marianoReset 
	default := nil.! !

Object subclass: #ConfigurationOfMartinDias
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'MartinDiasPersonalStuff'!

!ConfigurationOfMartinDias commentStamp: 'MarianoMartinezPeck 11/22/2011 17:02' prior: 0!
Explanation here: http://marianopeck.wordpress.com/2011/11/19/loading-projects-and-building-your-own-images-with-metacello/

Use:
ConfigurationOfMartinDias loadFuel.
ConfigurationOfMartinDias buildFuelImage.!

!ConfigurationOfMartinDias class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMartinDias class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMartinDias class methodsFor: 'building' stamp: 'sdas 10/28/2011 22:48'!
buildFuelImage
	FuelImageBuilder new buildImage.! !

!ConfigurationOfMartinDias class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMartinDias class methodsFor: 'private' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMartinDias class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMartinDias class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:23'!
loadFuel
	FuelImageBuilder new loadPackages: 'Fuel'! !

!ConfigurationOfMartinDias class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
project

	^self new project! !

!ConfigurationOfMartinDias class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMartinDias methodsFor: 'baselines' stamp: 'MartinDias 11/22/2011 16:12'!
baseline10: spec 
        <version: '1.0-baseline'>
        
	spec for: #pharo do: [
		
		spec blessing: #baseline.

  " =========================================
The following the list of projects that I DO DEVELOPE. Hence, I always want the bleedingEdge, and most of the times, I want to build an image for them. 
 ========================================="

		spec
			project: 'Fuel' with: [
			spec
				className: 'ConfigurationOfFuel';
				loads: #('DevelopmentGroup' );
				file: 'ConfigurationOfFuel';
				versionString: #bleedingEdge;
				repository: 'http://ss3.gemstone.com/ss/Fuel' ].



  " =========================================
The following the list of TOOLS, ADDONS  that I use for my own images. Since they are not my projects, I usually use the latest available metacello version and not the bleedingEdge.
In addition, not all tools and addons are loaded in all type of images I build. Each image decides what to include.
 ========================================="

					
		spec
			project: 'SandcastlesThemes' with: [
			spec
				className: 'ConfigurationOfSandcastleThemes';
				loads: #('default');
				file: 'ConfigurationOfSandcastleThemes';
				repository: 'http://www.squeaksource.com/SandcastlesThemes' ].
		
		spec
			project: 'TilingWindowManager' with: [
			spec
				className: 'ConfigurationOfTilingWindowManager';
				loads: #('default');
				file: 'ConfigurationOfTilingWindowManager';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/TilingWindowManager' ].
		
		spec
			project: 'Glamoroust' with: [
			spec
				className: 'ConfigurationOfGlamoroust';
				loads: #('GT-Inspector' 'GT-Playground' );
				file: 'ConfigurationOfGlamoroust';
				repository: 'http://www.squeaksource.com/glamoroust' ].
		
		spec project: 'Keymapping' with: [
			spec
				className: 'ConfigurationOfKeymapping';
				loads: #('forDeveloper' );
				file: 'ConfigurationOfKeymapping';
				versionString: #bleedingEdge;
				repository: 'http://www.squeaksource.com/ShortWays' ].
		
		
	
	
			
  " =========================================
The following is a list of groups for building my own images. Notice that for each image group there should be a class side method #buildXXXImage
 ========================================="
			
	
			
		spec
			group: 'FuelImage' with: #( 'BaseImage' 'SandcastlesThemes' 'Fuel');
			
			group: 'BaseImage' with: #('TilingWindowManager' "'Glamoroust'" 'Keymapping').

		 ].
	! !

!ConfigurationOfMartinDias methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/14/2011 23:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

Object subclass: #GeneralImageBuilder
	instanceVariableNames: ''
	classVariableNames: 'BuildOffline'
	poolDictionaries: ''
	category: 'MartinDiasPersonalStuff'!

GeneralImageBuilder subclass: #FuelImageBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MartinDiasPersonalStuff'!

!FuelImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 21:10'!
baseImageName
	^ 'Fuel'! !

!FuelImageBuilder methodsFor: 'preferences' stamp: 'MartinDias 11/22/2011 16:15'!
customPreferences
	(Smalltalk at: #FLLogoUtilities) installLogo.
"	PolymorphSystemSettings desktopImageFileName: '/Users/mariano/PhD/Marea/Fuel/fotos/1997_Need_For_Speed_2_Special_Edition.jpg'."
	(Smalltalk at: #SandcastlePharoway) beCurrent.
	Debugger logFileName: 'FuelDebug.log'.
	
! !

!FuelImageBuilder methodsFor: 'saving' stamp: ''!
imageDirectory
	^ 'D:\Fuel\images\'! !

!FuelImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ 'FuelImage'.	
! !

!FuelImageBuilder methodsFor: 'repositories' stamp: 'MartinDias 11/22/2011 16:14'!
repositoryName 
	^ 'http://ss3.gemstone.com/ss/Fuel'! !

!GeneralImageBuilder class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 14:36'!
buildOffline
	BuildOffline ifNil: [ BuildOffline := false ].
	^ BuildOffline! !

!GeneralImageBuilder class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 14:37'!
buildOffline: aBoolean
	BuildOffline := aBoolean! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/30/2011 16:12'!
buildImage
	self loadImagePackages.
	self generalImagePreferences.
	self customPreferences.
	self cleanSystem.
	self lastActions.
	self saveImage.! !

!GeneralImageBuilder methodsFor: 'cleaning' stamp: 'MarianoMartinezPeck 11/1/2011 19:56'!
cleanSystem
	SystemWindow allSubInstancesDo: [:window | window delete].

	"Clear Monticello Caches"
	MCFileBasedRepository flushAllCaches.
	MCMethodDefinition shutDown.
	MCDefinition clearInstances.

	"Cleanup Smalltalk"
	Smalltalk flushClassNameCache.
	Smalltalk organization removeEmptyCategories.
	Smalltalk allClassesAndTraitsDo: [ :each |
		each organization removeEmptyCategories; sortCategories.
		each class organization removeEmptyCategories; sortCategories ].
	
	"Cleanup System Memory"
	Smalltalk garbageCollect.
	Symbol compactSymbolTable.
	
	ScriptLoader new cleanUpForRelease.	

	"put back the author"
	Author fullName: 'MarianoMartinezPeck'.
	! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 10/21/2011 11:38'!
customPreferences! !

!GeneralImageBuilder methodsFor: 'preferences' stamp: 'MarianoMartinezPeck 11/21/2011 20:16'!
generalImagePreferences
	UITheme currentSettings fastDragging: true.
	CodeHolder showAnnotationPane: true.
	MCCodeTool showAnnotationPane: true.
	Deprecation raiseWarning: true.
	Debugger alwaysOpenFullDebugger: true.
	Parser warningAllowed: true. 
	TasklistMorph keepOpen: true.
	AutotestDashboard showAutotestDashboard: true.
	(Smalltalk at: #TWMBar) showTWMBar: true.
	"Smalltalk tools register: (Smalltalk at: #GTInspector)  as: #objectExplorer."
	" GTPlayground is not yet working correctly, so I disable it for the moment"
	"Smalltalk tools register: (Smalltalk at: #GTPlayground)  as: #workspace."
! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 11/22/2011 17:03'!
generalPreLoad
	MCCacheRepository marianoReset. 
	MCCacheRepository marianoDefaultWithDirectory: self sharedPackageCacheDirectory.
	MCDirectoryRepository defaultDirectoryName: self sharedPackageCacheName.
	Author fullName: self repositoriesUserName.
	
! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
imageGroupNameToLoad
	^ self subclassResponsibility ! !

!GeneralImageBuilder methodsFor: 'building' stamp: 'MarianoMartinezPeck 10/27/2011 16:46'!
lastActions
	self putMyRepositoriesAtTheEnd.
	self setSqueakSourceUsernameAndPassword.! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MarianoMartinezPeck 10/28/2011 11:22'!
loadImagePackages
	self loadPackages: self imageGroupNameToLoad.! !

!GeneralImageBuilder methodsFor: 'loading' stamp: 'MartinDias 11/22/2011 16:10'!
loadPackages: packagesOrGroups
	| version repo |
	self generalPreLoad.
	version := (ConfigurationOfMartinDias project version: #bleedingEdge).
	self class buildOffline 
		ifTrue: [ 
			repo := MCDirectoryRepository new.
  			repo directory: self sharedPackageCacheDirectory.
 	 		version repositoryOverrides: (OrderedCollection with: repo).
			 ].
	version load: packagesOrGroups.
	 ! !

!GeneralImageBuilder methodsFor: 'private' stamp: 'MarianoMartinezPeck 11/1/2011 20:01'!
putMyRepositoriesAtTheEnd
	| myRepo |
	myRepo :=  MCRepositoryGroup default repositories 
		detect: [:each | each description = self repositoryName]
		ifNone: [ "this means it was loaded offline used the shared package cache, so I do nothing" ^ self ].
	MCRepositoryGroup default  removeRepository: myRepo.
	MCRepositoryGroup default  addRepository: myRepo.
! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MarianoMartinezPeck 11/22/2011 17:02'!
repositoriesPassword
	^ (FileDirectory default oldFileNamed: 'D:\Fuel\ssMartinDiasPassword.txt') contents
! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MartinDias 11/22/2011 16:55'!
repositoriesUserName
	^ 'MartinDias'
! !

!GeneralImageBuilder methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/27/2011 16:47'!
repositoryName
	^ self subclassResponsibility ! !

!GeneralImageBuilder methodsFor: 'saving' stamp: 'MarianoMartinezPeck 10/17/2011 21:09'!
saveImage

	Smalltalk saveAs: self baseImageName inDirectoryNamed: self imageDirectory
! !

!GeneralImageBuilder methodsFor: 'private' stamp: 'MarianoMartinezPeck 11/22/2011 17:14'!
setSqueakSourceUsernameAndPassword
	"This sets the username and password in all repositories. The password must stored in a specific file in the machine where you are building this image."
	(MCRepositoryGroup default  repositories 
		select: [:each | (each isKindOf: MCHttpRepository) 
			and: [each locationWithTrailingSlash = self repositoryName]]) do: [:each |
			each 
				user: self repositoriesUserName;
				password: self repositoriesPassword.
			]! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MarianoMartinezPeck 10/21/2011 14:11'!
sharedPackageCacheDirectory.
	^ (FileDirectory on: self sharedPackageCacheName)
		assureExistence;
		yourself! !

!GeneralImageBuilder methodsFor: 'file directories' stamp: 'MarianoMartinezPeck 11/22/2011 17:02'!
sharedPackageCacheName
	^ 'D:\Fuel\localRepository\'! !

!SmalltalkImage methodsFor: '*martindiaspersonalstuff' stamp: 'MartinDias 11/22/2011 17:36'!
saveAs: imageName inDirectoryNamed: aDirectoryString

	| newName index |
	
	(FileDirectory default fileExists: (aDirectoryString , imageName, '.' , FileDirectory changeSuffix))
		ifTrue: [
			newName := (FileDirectory on: aDirectoryString ) nextNameFor: imageName extension: FileDirectory imageSuffix.
			"newName := UIManager default
				request: 'Please enter the name for the new image:'
				initialAnswer: newName."
			index := newName findLast: [:c | c = $.].
			newName := newName copyFrom: 1 to: (index - 1).
			
			]
		ifFalse: [ newName := imageName ].
	newName isEmptyOrNil
		ifTrue: [ ^ self ].
	(SourceFiles at: 2) ifNotNil:
		[self closeSourceFiles; "so copying the changes file will always work"
			 saveChangesInFileNamed: (aDirectoryString , newName, '.' , FileDirectory changeSuffix)].
	^self saveImageInFileNamed: (aDirectoryString , newName, '.', FileDirectory imageSuffix)! !
